/* types.h */
#include <stddef.h>
#include <limits.h>

extern char errorstring[];

#define MAXFNAMELEN    (1025U)

#define MAX_PARTICIPANT (127U)
#define NUMofQUERIES     (50U)
#define NUMofTYPES        (4U)
#define NUMofPRECISION    (2U)
#define NUMofINTERPOL    (11U)
#define NUMofNUMDOCS      (9U)
#define PARTI_NAME_LEN   (20)
#define QUERY_NAME_LEN    (5)

/* MAX_MATRIX */
#if MAX_PARTICIPANT > NUMofQUERIES
   #define MAX_MATRIX       MAX_PARTICIPANT
#else
   #define MAX_MATRIX       NUMofQUERIES
#endif

/* MAX_LEVEL */
#if NUMofNUMDOCS > NUMofINTERPOL
   #define MAX_LEVEL NUMofNUMDOCS
#else
   #define MAX_LEVEL NUMofINTERPOL
#endif
#if NUMofPRECISION > MAX_LEVEL
   #define MAX_LEVEL NUMofPRECISION
#endif

/* MAX_NAME_LEN */
#if PARTI_NAME_LEN > QUERY_NAME_LEN
   #define MAX_NAME_LEN PARTI_NAME_LEN
#else
   #define MAX_NAME_LEN QUERY_NAME_LEN
#endif

#define MAX_HISTO_LABEL (MAX_PARTICIPANT * NUMofQUERIES)

enum {AvPre = 0, RPre = 1, Interpol = 2, NumDoc = 3};

/* TYPES
     matrix_dim is an integer representing the dimensions of Matrix
     elem_t     is an integer representing the size of the Boolean array 
     ScreenSize is for #lines and #columns the display has
*/                 

typedef enum bool {FALSE, TRUE} bool;  
typedef double                  real;
typedef char *                  string;
typedef unsigned long           matrix_dim;
typedef matrix_dim              elem_t;
typedef unsigned short          ScreenSize;
typedef real                    prec_data[MAX_PARTICIPANT][NUMofQUERIES];


#define MAXscreenwidth (512U)
#define MAXscreenlines (USHRT_MAX)
#define SSZ_SPEC      "%hu"
#define REAL_SPEC     "% 7.5f"
#define POS_REAL_SPEC "%8.5f"
#define REAL_WIDTH    (8U)
#define MAT_DIM_SPEC  "%lu"
#define ELEM_SPEC     MAT_DIM_SPEC


#define on  'X'
#define off ' '

typedef void TransFuncType(real *);

typedef struct DataMatrix {
           prec_data  matrix;
           matrix_dim row_count;
           matrix_dim col_count;
           string     title;
           char       level[MAX_LEVEL * (4 + 2) + 1];
        } Matrix;

typedef bool bit;
typedef struct SelectionType {
           elem_t   size;    /* how many items in DS (selected or not) */
           elem_t   max;     /* maximum possible size */
           elem_t   max_len; /* maximum possible length of an item's name */
           bit  *   selected; 
           string * name;    /* names of items */
           string   title;   /* what data is represented by this struct? */
        } chose_t;

